-- Set up some local variables to track time and damage
local start_time = 0
local elapsed_time = 0.0
local COMBAT_R = 1
local COMBAT_G = 1
local COMBAT_B = 0
local NOCOMBAT_R = 0.5
local NOCOMBAT_G = 0.5
local NOCOMBAT_B = 0
local trigger_SW = 0  -- set 1 to also trigger the in-game stopwatch on combat


function CombatTime_OnLoad(frame)
	-- frame:RegisterEvent("UNIT_COMBAT")
	frame:RegisterEvent("PLAYER_REGEN_ENABLED")
	frame:RegisterEvent("PLAYER_REGEN_DISABLED")
  frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
  frame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
	frame:RegisterForClicks("RightButtonUp")
	frame:RegisterForDrag("LeftButton")
  CombatTimeFrameText:SetTextColor(NOCOMBAT_R,NOCOMBAT_G,NOCOMBAT_B,1)		
--	CombatTimeFrame:Hide()
end

function CombatTime_OnEvent(frame, event, ...)
	if event == "PLAYER_REGEN_ENABLED" then
		-- This event is called when the player exits combat
    CombatTimeFrameText:SetTextColor(NOCOMBAT_R,NOCOMBAT_G,NOCOMBAT_B,1)			
		CombatTime_UpdateText()
    CombatTimeFrame:SetScript("OnUpdate", nil);			
		
    if (trigger_SW and StopwatchFrame and StopwatchFrame:IsShown()) then
       Stopwatch_Pause()
    end		
	elseif event == "PLAYER_REGEN_DISABLED" then
		-- This event is called when we enter combat
		-- start the timer
		start_time = GetTime()
    CombatTimeFrameText:SetTextColor(COMBAT_R,COMBAT_G,COMBAT_B,1)		
    CombatTimeFrame:SetScript("OnUpdate", CombatTime_OnUpdate);			
    CombatTime_UpdateText();
    		
    if (trigger_SW and StopwatchFrame and StopwatchFrame:IsShown() and not Stopwatch_IsPlaying()) then
       Stopwatch_Clear()
       Stopwatch_Play()
    end
	elseif event == "ADDON_LOADED" then  
	  if not CombatTime_posX then
	    CombatTime_posX = 0
	  end
	  if not CombatTime_posY then
	    CombatTime_posY = 0
	  end	  
	  -- CombatTimeFrame:SetPoint("TOP", "Minimap","BOTTOM", CombatTime_posX, CombatTime_posY)
	  -- CombatTimeFrame:SetPoint("CENTER", "UIParent", "CENTER", CombatTime_posX, CombatTime_posY)
	  CombatTimeFrame:SetUserPlaced(true) -- this autoloads the last position
	elseif event == "PLAYER_LOGOUT" then
	  -- local point, relativeTo, relativePoint, xOffset, yOffset = CombatTimeFrame:GetPoint(1)
	  local  xOffset, yOffset = CombatTimeFrame:GetCenter() ;
	  CombatTime_posX = xOffset
	  CombatTime_posY = yOffset
	  CombatTimeFrame:SetUserPlaced(true)
	end
end

function CombatTime_OnUpdate(self, elapsed)
    CombatTime_UpdateText(elapsed);
end

local SEC_TO_MINUTE_FACTOR = 1/60;
local SEC_TO_HOUR_FACTOR = SEC_TO_MINUTE_FACTOR*SEC_TO_MINUTE_FACTOR;

function CombatTime_UpdateText(elapsed)
  if elapsed then -- optimize away unnecessary updates
     elapsed_time = elapsed_time + elapsed
     if elapsed_time < 0.25 then
       return
     end
  else
     elapsed_time = 0.0
  end
  local total_time = GetTime() - start_time;
  local hour = min(floor(total_time*SEC_TO_HOUR_FACTOR), 99);
  local minute = mod(total_time*SEC_TO_MINUTE_FACTOR, 60);
  local second = mod(total_time, 60);	

	local status = string.format("%02d:%02d:%02d", hour, minute, second)

	CombatTimeFrameText:SetText(status)
end

